## Folder Structure
- **client** - easy to use client for CMS API that provides high level abstractions over its operations. It contains the client itself and service classes that allows to work with API in RPC style. This python package can be used freely in user applications.
  - **proto** - python modules that are generated from the protocol using [this instruction](protocol/readme.md).
- **logs** - logs (in text format) of a use case run. Logs contains text representation of every message that was sent to (*Message out*) or from (*Message in*) CMS.
- **protocol** - CMS API protocol files and means to generate python (or any other supported language) classes.
- **use_cases** - scripts that demonstrate different use cases of getting things done with CMS API. They are not supposed to be used as is, but rather as a template.
- **.vscode** - contains configuration to run samples in VS Code in debug mode (F5).

## Setup
Python 3.9+ is required (https://www.python.org/downloads/), yet the latest version is recommended.

### Install Dependencies
1. *(optional)* Activate virtual environment (see [instruction](https://docs.python.org/3/tutorial/venv.html) for details).

    python -m venv <venv_folder>

    <venv_folder>/scripts/activate.bat

2. Navigate to the root samples directory (*where [requirements.txt](requirements.txt) is located*).
3. Run setup.cmd (Windows).

### Configuration
Fill user-specific data in [config](config.py).

### Launch Samples
There are several options of how to run the samples:

- Using free [Visual Studio Code](https://code.visualstudio.com/).
  - [Microsoft Python](https://marketplace.visualstudio.com/items?itemName=ms-python.python) extension is required.
  - Change [launch.json](.vscode/launch.json) "args" parameter to specify a use case to run.
  - Change Python interpreter (Python: Select Interpreter command) to the one you are using (it can be python.exe from your virtual environment).

- Using run.cmd (Windows), giving use case name as parameter.
Example:

    run.cmd account_setup